#property copyright "IgorM"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Yellow
#property indicator_width2 1
#property indicator_style2 1
#property indicator_color3 Lime
#property indicator_width3 1
#property indicator_style3 2

//
//
//
//
//

extern string TimeFrame             = "Current time frame";
extern int    short_term_SMA_period = 20;
extern int    long_term_EMA_period  = 40;    
extern double smooth                = 5; 
extern bool   use_eursek            = false;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   
   SetIndexBuffer(0,Buffer1); SetIndexLabel(0,"EURX");
   SetIndexBuffer(1,Buffer2); SetIndexLabel(1,short_term_SMA_period+"SMA");
   SetIndexBuffer(2,Buffer3); SetIndexLabel(2,long_term_EMA_period+"EMA"); 
   
    //
    //
    //
    //
    //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
    //
    //
    //
    //
    //
     
   IndicatorShortName(timeFrameToString(timeFrame)+" EUR_Index_SMA_EMA smooth: EURX / "+short_term_SMA_period+"SMA / "+long_term_EMA_period+"EMA");
return(0);
}

//
//
//
//
//

int deinit() {  return(0); }

//
//
//
//
//

int start()
{
   int    counted_bars = IndicatorCounted();
   int    i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   { 

      for(i=limit; i>=0; i--) 
         if (use_eursek) 
         { 
            Buffer1[i] = 34.38805726 * iSsm(MathPow(iClose("EURUSD",0,i),0.3155) *  
                                           MathPow(iClose("EURGBP",0,i),0.3056) * 
                                           MathPow(iClose("EURJPY",0,i),0.1891) * 
                                           MathPow(iClose("EURCHF",0,i),0.1113) * 
                                           MathPow(iClose("EURSEK",0,i),0.0785),smooth,i); 
          }
          else  
          { 
            Buffer1[i] = 34.38805726 * iSsm(MathPow(iClose("EURUSD",0,i),0.3155) *  
                                            MathPow(iClose("EURGBP",0,i),0.3056) * 
                                            MathPow(iClose("EURJPY",0,i),0.1891) * 
                                            MathPow(iClose("EURCHF",0,i),0.1113),smooth,i); 
          } 
   
      for(i=limit; i>=0; i--)
      {
         Buffer2[i]=0;
         Buffer3[i]=0;
      
         for(int z = 0; z < short_term_SMA_period; z++) { Buffer2[i] = Buffer2[i]+Buffer1[i+z]; }
          
         Buffer2[i] = Buffer2[i]/short_term_SMA_period;
         if(Buffer1[i] > 0)
         Buffer3[i] = Buffer1[i]*(2.0/(long_term_EMA_period+1))+Buffer3[i+1]*(1-(2.0/(long_term_EMA_period+1)));   
      }
   return(0);
   }
   
   //
   //
   //
   //
   //
  
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
          Buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",short_term_SMA_period,long_term_EMA_period,smooth,0,y);
          Buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",short_term_SMA_period,long_term_EMA_period,smooth,1,y);
          Buffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",short_term_SMA_period,long_term_EMA_period,smooth,2,y);
          
            
    }
return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double workSsm[][2];
#define _tprice 0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

double iSsm(double tprice, double period, int i, int instanceNo=0)
{
   if (period<=1) return(tprice); i = Bars-i-1;
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
          workSsm[i][s+_tprice] = tprice;
          workSsm[i][s+_ssm]    = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                  workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                  workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
   return(workSsm[i][s+_ssm]);
}

//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

